

const SCROLL_VALUE_EVENT8 = 53; // Scrolling value for triggering event8, which indicates user's engagement
const VIEW_TIME_EVENT8 = 10; // View time value for triggering event 8, which helps to filter pseudo-engagement

const INTERACTION_TIME = 10; // seconds on page to consider click is not bounced


var wrapUrlWithClickId = (function() {
	"use strict";

	function n(n, r) {
		var e;
		void 0 === r && (r = "uclick");
		var u = null === (e = n.match(/\?.+?$/)) || void 0 === e ? void 0 : e[0];
		return u ? Array.from(u.matchAll(new RegExp("[?&](clickid|" + r + ")=([^=&]*)", "g"))).map((function(n) {
			return {
				name: n[1],
				value: n[2]
			}
		})) : []
	}

	function r(n) {
		var r = n();
		return 0 === r.length ? {} : r.reduce((function(n, r) {
			var e;
			return Object.assign(n, ((e = {})[r.name] = "" + r.value, e))
		}), {})
	}

	function e(e) {
		void 0 === e && (e = "uclick");
		var u, i, t = r((function() {
				return (function(n) {
					return void 0 === n && (n = "uclick"), Array.from(document.cookie.matchAll(new RegExp("(?:^|; )(clickid|" + n + ")=([^;]*)", "g"))).map((function(n) {
						return {
							name: n[1],
							value: n[2]
						}
					}))
				})(e)
			})),
			c = r((function() {
				return n(document.referrer, e)
			})),
			a = r((function() {
				return n(document.location.search, e)
			}));
		return (u = [e, "clickid"], i = [t, c, a], u.reduce((function(n, r) {
			return n.concat(i.map((function(n) {
				return [r, n]
			})))
		}), [])).map((function(n) {
			return {
				name: n[0],
				value: n[1][n[0]]
			}
		})).find((function(n) {
			return n.value
		})) || null
	}

	function u(n, r, e) {
		var u = n.replace(new RegExp(r + "=[^=&]*", "g"), r + "=" + e);
		return -1 !== u.indexOf(r) ? u : (function(n, r, e) {
			var u = n.trim(),
				i = r + "=" + e;
			return -1 === u.indexOf("?") ? u + "?" + i : u.endsWith("?") ? "" + u + i : u + "&" + i
		})(n, r, e)
	}
	return function(n, r) {
		void 0 === r && (r = "uclick");
		var i = e(r);
		return null === i ? n : n.includes("cnv_id") ? i.name === r ? u(n, i.name, i.value) : i.value ? u(n, "cnv_id", i.value) : n : u(n, i.name, i.value)
	}
})();

var img = null;
var img2 = null;

var click_time = Date.now();
var timedelta = 0;
var sentP = 0; // for scrollPusher
var DOMAIN = window.location.hostname;
var event_sent = false;

var scrolled = false;
var viewed_10s = false;

function pushEvent(event, value){
    if (img2 != null) {
        img2.remove();
    }
    var img2 = document.createElement('img');
    img2.src = wrapUrlWithClickId('./click.php?'+ event +'=' + value     
                                                + "&sub_id_10=" + a
                                                + "&sub_id_11=" + b
                                                + "&sub_id_12=" + c
                                                + "&sub_id_13=" + d
                                                + "&date=" + f
                                                + "&external_ID=" + g
                                                + "&client_ip_address=" + h
                                                + "&client_user_agent=" + k
                                                + "&ct=" + l
                                                + "&st=Unknown"
                                                + "&country=" + p 
    );
    img2.referrerPolicy = 'no-referrer-when-downgrade';
    img2.style.display = 'none';
    document.body.appendChild(img2);
}


// push on start
// pushEvent('pv', 1);

function pushAddEvent(event, value){
    if (img != null) {
        img.remove();
    }
    var img = document.createElement('img');
    img.src = wrapUrlWithClickId('./click.php?add_'+ event +'=' + value 
                                                    + "&sub_id_10=" + a
                                                    + "&sub_id_11=" + b
                                                    + "&sub_id_12=" + c
                                                    + "&sub_id_13=" + d
                                                    + "&date=" + f
                                                    + "&external_ID=" + g
                                                    + "&client_ip_address=" + h
                                                    + "&client_user_agent=" + k
                                                    + "&ct=" + l
                                                    + "&st=Unknown"
                                                    + "&country=" + p
                                                    );
    img.referrerPolicy = 'no-referrer-when-downgrade';
    img.style.display = 'none';
    document.body.appendChild(img);
}

function viewTimeAddPusher(interval){
    setInterval(function(){ 
        timedelta = Math.floor( (Date.now() - click_time) / 1000);

        // pushAddEvent('event6', interval);

        if ((viewed_10s == false) && (timedelta > 9)){
          
            // 10se
            pushEvent('pv', 2);
            viewed_10s = true;
            
        }

    }, interval*1000)
}

function scrollPercentPusher(minChange, timeout){
    
    let lastPushTime = 0; // This will record the last time the event was pushed.
    let pushEventCooldown = 2000; // 2 seconds in milliseconds.

    function updateEvent(new_value) {
        const currentTime = Date.now();

        // if (new_value - sentP > 2 && currentTime - lastPushTime > pushEventCooldown) {
        //     sentP = new_value;
        //     pushEvent('event7', sentP>100?100:Math.floor(sentP));
        //     lastPushTime = currentTime; // Update the last push time.
            
        //     if (scrolled == false && new_value > 3){
        //         scrolled = true;
        //     }
        // }

        // if ((viewed_10s == true) && (scrolled == true)){
        //     pushEvent('event5', 1);
        // }
        // console.log(new_value, timedelta);
        if (new_value >= 50 && timedelta >= VIEW_TIME_EVENT8 && event_sent == false){
            console.log('viewContent');
            pushEvent('vc', 1);
            event_sent = true;
        }
    }

    window.addEventListener('scroll', function(e) {
        scrollpercent = window.scrollY / (document.body.scrollHeight - window.screen.height) * 100;
        // console.log(scrollpercent);
        updateEvent(scrollpercent);
    });
}


var VIEW_TIME_PUSH_INTERVAL = 10;
var SCROLL_PERCENT_INTERVAL = 5;
var SCROLL_PERCENT_TIMEOUT = 2000;

var IS_PAGEVIEW_PUSHED = 0;


viewTimeAddPusher(VIEW_TIME_PUSH_INTERVAL);
scrollPercentPusher(SCROLL_PERCENT_INTERVAL, SCROLL_PERCENT_TIMEOUT);

console.log('behaviour.js initiated - v. 1.5e');
